using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ProcessManager : BaseManager<ProcessManager>
{
    /// <summary>
    /// 캯
    /// </summary>
    private ProcessManager() { }

    /// <summary>
    /// ʵĿid
    /// </summary>
    public int id;

    /// <summary>
    /// ģʽ
    /// </summary>
    public E_ModeType mode;

    /// <summary>
    /// ǰĿ/
    /// </summary>
    public D_Scheme d_Scheme;

    /// <summary>
    /// ǰId
    /// </summary>
    public int processId = -1;

    /// <summary>
    /// ǰId
    /// </summary>
    public int subProcessId = -1;

    /// <summary>
    /// ǰ̲Id
    /// </summary>
    public int subProcessStepId = -1;

    /// <summary>
    /// ʼ
    /// ݷid 
    /// </summary>
    /// <param name="id">id</param>
    public void Init(int id, E_ModeType mode)
    {
        this.id = id;
        this.mode = mode;
        d_Scheme = DataManager.Instance.GetSchemeData(id);
        ReportManager.Instance.creport = DataManager.Instance.GetSchemeReport(id);
        d_Scheme.Init();
        Debug.Log("̳ʼ");
    }

    /// <summary>
    /// л
    /// </summary>
    public void HandoverProcess(int processId, int subProcessId, int subProcessStepId)
    {
        if (processId == -1 || subProcessId == -1 || subProcessStepId == -1)
            return;
        d_Scheme.HandoverProcess(processId, subProcessId, subProcessStepId);
    }

    /// <summary>
    /// л
    /// </summary>
    public void HandoverSubProcess(int subProcessId, int subProcessStepId)
    {
        if (processId == -1 || subProcessId == -1 || subProcessStepId == -1)
            return;
        d_Scheme.HandoverProcess(processId, subProcessId, subProcessStepId);
    }

    /// <summary>
    /// л
    /// </summary>
    public void HandoverSubProcessStep(int subProcessStepId)
    {
        if (processId == -1 || subProcessId == -1 || subProcessStepId == -1)
            return;
        d_Scheme.HandoverProcess(processId, subProcessId, subProcessStepId);
    }

    /// <summary>
    /// 
    /// </summary>
    public void End()
    {
        id = -1;
        mode = E_ModeType.None;
        d_Scheme = null;
    }
}
