using System;
using System.Reflection;
using UnityEngine;
/// <summary>
/// 
/// </summary>
/// <typeparam name="T"></typeparam>
public abstract class BaseManager<T> where T : class
{
    private static T instance;

    /// <summary>
    /// ߳
    /// </summary>
    protected static readonly object lockObj = new object();

    public static T Instance
    {
        get
        {
            if (instance == null)
            {
                lock (lockObj)
                {
                    if (instance == null)
                    {
                        //ֱActivator 
                        instance = (T)Activator.CreateInstance(typeof(T), true);
                        /*
                        //ͨȡ ޲˽й캯  Ҫ˽й캯
                        Type type = typeof(T);
                        ConstructorInfo info = type.GetConstructor(BindingFlags.Instance | BindingFlags.NonPublic, null, Type.EmptyTypes, null);
                        if (info != null)
                            instance = info.Invoke(null) as T;
                        else
                            Debug.LogError("ûеõӦ޲ι캯");
                        */
                    }
                }
            }
            return instance;
        }
    }
}
